uniform sampler2DShadow texture0;
uniform samplerCube texture1;
varying vec4 ambient;

void main (void)
{		
	vec4 shadowColor = shadow2DProj(texture0, gl_TexCoord[0]);
	vec4 specular = textureCube(texture1, gl_TexCoord[1].xyz);	
	vec4 diffuseShadow = clamp(shadowColor, vec4(.2, .2, .2, 1.0), vec4(1.0, 1.0, 1.0, 1.0));
	
	gl_FragColor = ambient + gl_Color * diffuseShadow + specular * shadowColor;
}