uniform vec2 bias;

varying vec4 ambient;

void main (void)
{
	vec4 eyePos;
	vec3 normal;
	vec3 lightVector;
	vec3 viewVector;
	float diffuseDotProd;
	float diffuseDotProd1;
	vec4 diffuse;
	
	eyePos = gl_ModelViewMatrix * gl_Vertex;
	normal = normalize(gl_NormalMatrix * gl_Normal);
	lightVector = normalize(gl_LightSource[0].position.xyz - eyePos.xyz);
	viewVector = normalize(-eyePos.xyz); 	// The camera is at the origin of view coordinates
	
	diffuseDotProd = dot(normal, lightVector);
	diffuseDotProd1 = 1.0 - diffuseDotProd;
	
	gl_TexCoord[0] = gl_TextureMatrix[0] * eyePos + vec4(0.0, 0.0, -(bias[0] + bias[1] * diffuseDotProd1*diffuseDotProd1), 0.0);
	gl_TexCoord[1] = gl_TextureMatrix[1] * vec4(reflect(-viewVector, normal), 1.0);
		
	ambient  = gl_LightModel.ambient * gl_FrontMaterial.ambient;
	diffuse  = gl_FrontLightProduct[0].diffuse * max(diffuseDotProd, 0.0);
	
	gl_FrontColor = diffuse;
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;

}