varying vec4 ambient;

uniform vec2 bias;

void main (void)
{
	vec3 eyeNormal, reflection[2], view, L;
	vec4 eyePos, diffuse, specular;
	float d, d1;

	eyeNormal = normalize(gl_NormalMatrix * gl_Normal);
	eyePos = gl_ModelViewMatrix * gl_Vertex;
		
	L = normalize(gl_LightSource[0].position.xyz - eyePos.xyz);
	d = dot(eyeNormal, L);
	d1 = 1.0 - d;
	
	gl_TexCoord[0] = gl_TextureMatrix[0] * eyePos + 
			 vec4(0.0, 0.0, -(bias[0] + bias[1] * d1*d1), 0.0);

	view = normalize(-eyePos.xyz); 	// The camera is at the origin of view coordinates
	

	gl_TexCoord[1] = gl_TextureMatrix[1] * vec4(reflect(-view, eyeNormal), 1.0);
	
	ambient  = gl_LightModel.ambient * gl_FrontMaterial.ambient;
	diffuse  = gl_FrontLightProduct[0].diffuse * max(d, 0.0);
	
	gl_FrontColor = diffuse;
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
}
